<!DOCTYPE html><html lang="zh-CN" data-theme="light"><head><meta charset="UTF-8"><meta http-equiv="X-UA-Compatible" content="IE=edge"><meta name="viewport" content="width=device-width,initial-scale=1"><title>kubeadm集群证书续签 | SeMaik</title><meta name="author" content="ZuSir"><meta name="copyright" content="ZuSir"><meta name="format-detection" content="telephone=no"><meta name="theme-color" content="#ffffff"><meta name="description" content="12345678910111213141516171819202122232425262728293031323334353637383940414243444546474849505152535455565758596061626364656667686970717273747576777879808182838485868788899091929394959697989910010110210">
<meta property="og:type" content="article">
<meta property="og:title" content="kubeadm集群证书续签">
<meta property="og:url" content="http://example.com/2021/11/03/ubeadm%E8%AF%81%E4%B9%A6%E7%BB%AD%E7%AD%BEjioaben/index.html">
<meta property="og:site_name" content="SeMaik">
<meta property="og:description" content="12345678910111213141516171819202122232425262728293031323334353637383940414243444546474849505152535455565758596061626364656667686970717273747576777879808182838485868788899091929394959697989910010110210">
<meta property="og:locale" content="zh_CN">
<meta property="og:image" content="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg">
<meta property="article:published_time" content="2021-11-03T08:08:00.000Z">
<meta property="article:modified_time" content="2021-11-03T08:10:54.000Z">
<meta property="article:author" content="ZuSir">
<meta name="twitter:card" content="summary">
<meta name="twitter:image" content="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg"><link rel="shortcut icon" href="https://myit.icu/favicon.ico"><link rel="canonical" href="http://example.com/2021/11/03/ubeadm%E8%AF%81%E4%B9%A6%E7%BB%AD%E7%AD%BEjioaben/"><link rel="preconnect" href="//cdn.jsdelivr.net"/><link rel="preconnect" href="//busuanzi.ibruce.info"/><link rel="stylesheet" href="/css/index.css"><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@fortawesome/fontawesome-free/css/all.min.css" media="print" onload="this.media='all'"><script>const GLOBAL_CONFIG = { 
  root: '/',
  algolia: undefined,
  localSearch: undefined,
  translate: undefined,
  noticeOutdate: undefined,
  highlight: {"plugin":"highlighjs","highlightCopy":true,"highlightLang":true},
  copy: {
    success: '复制成功',
    error: '复制错误',
    noSupport: '浏览器不支持'
  },
  relativeDate: {
    homepage: true,
    post: false
  },
  runtime: '',
  date_suffix: {
    just: '刚刚',
    min: '分钟前',
    hour: '小时前',
    day: '天前',
    month: '个月前'
  },
  copyright: undefined,
  lightbox: 'fancybox',
  Snackbar: undefined,
  source: {
    jQuery: 'https://cdn.jsdelivr.net/npm/jquery@latest/dist/jquery.min.js',
    justifiedGallery: {
      js: 'https://cdn.jsdelivr.net/npm/justifiedGallery/dist/js/jquery.justifiedGallery.min.js',
      css: 'https://cdn.jsdelivr.net/npm/justifiedGallery/dist/css/justifiedGallery.min.css'
    },
    fancybox: {
      js: 'https://cdn.jsdelivr.net/npm/@fancyapps/fancybox@latest/dist/jquery.fancybox.min.js',
      css: 'https://cdn.jsdelivr.net/npm/@fancyapps/fancybox@latest/dist/jquery.fancybox.min.css'
    }
  },
  isPhotoFigcaption: false,
  islazyload: false,
  isanchor: false
}</script><script id="config-diff">var GLOBAL_CONFIG_SITE = { 
  isPost: true,
  isHome: false,
  isHighlightShrink: undefined,
  isToc: false,
  postUpdate: '2021-11-03 16:10:54'
}</script><noscript><style type="text/css">
  #nav {
    opacity: 1
  }
  .justified-gallery img {
    opacity: 1
  }

  #recent-posts time,
  #post-meta time {
    display: inline !important
  }
</style></noscript><script>(win=>{
    win.saveToLocal = {
      set: function setWithExpiry(key, value, ttl) {
        if (ttl === 0) return
        const now = new Date()
        const expiryDay = ttl * 86400000
        const item = {
          value: value,
          expiry: now.getTime() + expiryDay,
        }
        localStorage.setItem(key, JSON.stringify(item))
      },

      get: function getWithExpiry(key) {
        const itemStr = localStorage.getItem(key)

        if (!itemStr) {
          return undefined
        }
        const item = JSON.parse(itemStr)
        const now = new Date()

        if (now.getTime() > item.expiry) {
          localStorage.removeItem(key)
          return undefined
        }
        return item.value
      }
    }
  
    win.getScript = url => new Promise((resolve, reject) => {
      const script = document.createElement('script')
      script.src = url
      script.async = true
      script.onerror = reject
      script.onload = script.onreadystatechange = function() {
        const loadState = this.readyState
        if (loadState && loadState !== 'loaded' && loadState !== 'complete') return
        script.onload = script.onreadystatechange = null
        resolve()
      }
      document.head.appendChild(script)
    })
  
      const asideStatus = saveToLocal.get('aside-status')
      if (asideStatus !== undefined) {
        if (asideStatus === 'hide') {
          document.documentElement.classList.add('hide-aside')
        } else {
          document.documentElement.classList.remove('hide-aside')
        }
      }
    })(window)</script><link href="/css/style.css"><meta name="generator" content="Hexo 5.3.0"><link rel="alternate" href="/atom.xml" title="SeMaik" type="application/atom+xml">
</head><body><div id="web_bg"></div><div id="sidebar"><div id="menu-mask"></div><div id="sidebar-menus"><div class="author-avatar"><img class="avatar-img" src="/img/123.jpeg" onerror="onerror=null;src='/img/123.jpeg'" alt="avatar"/></div><div class="site-data"><div class="data-item is-center"><div class="data-item-link"><a href="/archives/"><div class="headline">文章</div><div class="length-num">152</div></a></div></div><div class="data-item is-center"><div class="data-item-link"><a href="/categories/"><div class="headline">分类</div><div class="length-num">37</div></a></div></div></div><hr/><div class="menus_items"><div class="menus_item"><a class="site-page" href="/"><i class="fa-fw fas fa-home"></i><span> 首页</span></a></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Linux</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Linux/"><span> Linux</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> WEB</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Apache/"><span> Apache</span></a></li><li><a class="site-page" href="/categories/Nginx/"><span> Nginx</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 存储</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ceph/"><span> Ceph</span></a></li><li><a class="site-page" href="/categories/NFS/"><span> NFS</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 日志</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Loki"><span> Loki</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 编程</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Shell"><span> Shell</span></a></li><li><a class="site-page" href="/categories/Python"><span> Python</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 高可用</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/KeepAlived/"><span> KeepAlived</span></a></li><li><a class="site-page" href="/categories/LVS/"><span> LVS</span></a></li><li><a class="site-page" href="/categories/Squid/"><span> Squid</span></a></li><li><a class="site-page" href="/categories/Haproxy/"><span> Haproxy</span></a></li><li><a class="site-page" href="/categories/Rsync/"><span> Rsync</span></a></li><li><a class="site-page" href="/categories/Memcache/"><span> Memcache</span></a></li><li><a class="site-page" href="/categories/Varnish/"><span> Varnish</span></a></li><li><a class="site-page" href="/categories/GRedis/"><span> Redis</span></a></li><li><a class="site-page" href="/categories/Rabbit/"><span> RabbitMQ</span></a></li><li><a class="site-page" href="/categories/Kafka/"><span> Kafka</span></a></li><li><a class="site-page" href="/categories/MHA/"><span> MHA</span></a></li><li><a class="site-page" href="/categories/PXC/"><span> PXC</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 虚拟化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Docker/"><span> Docker</span></a></li><li><a class="site-page" href="/categories/Kubernetes/"><span> Kubernetes</span></a></li><li><a class="site-page" href="/categories/OpenStack/"><span> OpenStack</span></a></li><li><a class="site-page" href="/categories/KVM/"><span> KVM</span></a></li><li><a class="site-page" href="/categories/Containerd"><span> Containerd</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Hexo</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Hexo/"><span> Hexo</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 数据库</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/MySQL/"><span> MySQL</span></a></li><li><a class="site-page" href="/categories/Readis/"><span> Readis</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 微服务</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Tomcat/"><span> Tomcat</span></a></li><li><a class="site-page" href="/categories/Git/"><span> Git</span></a></li><li><a class="site-page" href="/categories/Maven/"><span> Maven</span></a></li><li><a class="site-page" href="/categories/Nexus/"><span> Nexus</span></a></li><li><a class="site-page" href="/categories/Jenkins/"><span> Jenkins</span></a></li><li><a class="site-page" href="/categories/Spring/"><span> Spring</span></a></li><li><a class="site-page" href="/categories/Consul/"><span> Consul</span></a></li><li><a class="site-page" href="/categories/Harbor/"><span> Harbor</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 自动化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ansible/"><span> Ansible</span></a></li><li><a class="site-page" href="/categories/Pssh/"><span> Pssh</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="/link/"><i class="fa-fw fas fa-link"></i><span> 友链</span></a></div><div class="menus_item"><a class="site-page" href="/about/"><i class="fa-fw fas fa-heart"></i><span> 关于</span></a></div></div></div></div><div class="post" id="body-wrap"><header class="post-bg" id="page-header" style="background-image: url('https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg')"><nav id="nav"><span id="blog_name"><a id="site-name" href="/">SeMaik</a></span><div id="menus"><div class="menus_items"><div class="menus_item"><a class="site-page" href="/"><i class="fa-fw fas fa-home"></i><span> 首页</span></a></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Linux</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Linux/"><span> Linux</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> WEB</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Apache/"><span> Apache</span></a></li><li><a class="site-page" href="/categories/Nginx/"><span> Nginx</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 存储</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ceph/"><span> Ceph</span></a></li><li><a class="site-page" href="/categories/NFS/"><span> NFS</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 日志</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Loki"><span> Loki</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 编程</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Shell"><span> Shell</span></a></li><li><a class="site-page" href="/categories/Python"><span> Python</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 高可用</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/KeepAlived/"><span> KeepAlived</span></a></li><li><a class="site-page" href="/categories/LVS/"><span> LVS</span></a></li><li><a class="site-page" href="/categories/Squid/"><span> Squid</span></a></li><li><a class="site-page" href="/categories/Haproxy/"><span> Haproxy</span></a></li><li><a class="site-page" href="/categories/Rsync/"><span> Rsync</span></a></li><li><a class="site-page" href="/categories/Memcache/"><span> Memcache</span></a></li><li><a class="site-page" href="/categories/Varnish/"><span> Varnish</span></a></li><li><a class="site-page" href="/categories/GRedis/"><span> Redis</span></a></li><li><a class="site-page" href="/categories/Rabbit/"><span> RabbitMQ</span></a></li><li><a class="site-page" href="/categories/Kafka/"><span> Kafka</span></a></li><li><a class="site-page" href="/categories/MHA/"><span> MHA</span></a></li><li><a class="site-page" href="/categories/PXC/"><span> PXC</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 虚拟化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Docker/"><span> Docker</span></a></li><li><a class="site-page" href="/categories/Kubernetes/"><span> Kubernetes</span></a></li><li><a class="site-page" href="/categories/OpenStack/"><span> OpenStack</span></a></li><li><a class="site-page" href="/categories/KVM/"><span> KVM</span></a></li><li><a class="site-page" href="/categories/Containerd"><span> Containerd</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Hexo</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Hexo/"><span> Hexo</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 数据库</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/MySQL/"><span> MySQL</span></a></li><li><a class="site-page" href="/categories/Readis/"><span> Readis</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 微服务</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Tomcat/"><span> Tomcat</span></a></li><li><a class="site-page" href="/categories/Git/"><span> Git</span></a></li><li><a class="site-page" href="/categories/Maven/"><span> Maven</span></a></li><li><a class="site-page" href="/categories/Nexus/"><span> Nexus</span></a></li><li><a class="site-page" href="/categories/Jenkins/"><span> Jenkins</span></a></li><li><a class="site-page" href="/categories/Spring/"><span> Spring</span></a></li><li><a class="site-page" href="/categories/Consul/"><span> Consul</span></a></li><li><a class="site-page" href="/categories/Harbor/"><span> Harbor</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 自动化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ansible/"><span> Ansible</span></a></li><li><a class="site-page" href="/categories/Pssh/"><span> Pssh</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="/link/"><i class="fa-fw fas fa-link"></i><span> 友链</span></a></div><div class="menus_item"><a class="site-page" href="/about/"><i class="fa-fw fas fa-heart"></i><span> 关于</span></a></div></div><div id="toggle-menu"><a class="site-page"><i class="fas fa-bars fa-fw"></i></a></div></div></nav><div id="post-info"><h1 class="post-title">kubeadm集群证书续签</h1><div id="post-meta"><div class="meta-firstline"><span class="post-meta-date"><i class="far fa-calendar-alt fa-fw post-meta-icon"></i><span class="post-meta-label">发表于</span><time class="post-meta-date-created" datetime="2021-11-03T08:08:00.000Z" title="发表于 2021-11-03 16:08:00">2021-11-03</time><span class="post-meta-separator">|</span><i class="fas fa-history fa-fw post-meta-icon"></i><span class="post-meta-label">更新于</span><time class="post-meta-date-updated" datetime="2021-11-03T08:10:54.000Z" title="更新于 2021-11-03 16:10:54">2021-11-03</time></span><span class="post-meta-categories"><span class="post-meta-separator">|</span><i class="fas fa-inbox fa-fw post-meta-icon"></i><a class="post-meta-categories" href="/categories/Kubernetes/">Kubernetes</a></span></div><div class="meta-secondline"><span class="post-meta-separator">|</span><span class="post-meta-pv-cv"><i class="far fa-eye fa-fw post-meta-icon"></i><span class="post-meta-label">阅读量:</span><span id="busuanzi_value_page_pv"></span></span></div></div></div></header><main class="layout" id="content-inner"><div id="post"><article class="post-content" id="article-container"><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br><span class="line">14</span><br><span class="line">15</span><br><span class="line">16</span><br><span class="line">17</span><br><span class="line">18</span><br><span class="line">19</span><br><span class="line">20</span><br><span class="line">21</span><br><span class="line">22</span><br><span class="line">23</span><br><span class="line">24</span><br><span class="line">25</span><br><span class="line">26</span><br><span class="line">27</span><br><span class="line">28</span><br><span class="line">29</span><br><span class="line">30</span><br><span class="line">31</span><br><span class="line">32</span><br><span class="line">33</span><br><span class="line">34</span><br><span class="line">35</span><br><span class="line">36</span><br><span class="line">37</span><br><span class="line">38</span><br><span class="line">39</span><br><span class="line">40</span><br><span class="line">41</span><br><span class="line">42</span><br><span class="line">43</span><br><span class="line">44</span><br><span class="line">45</span><br><span class="line">46</span><br><span class="line">47</span><br><span class="line">48</span><br><span class="line">49</span><br><span class="line">50</span><br><span class="line">51</span><br><span class="line">52</span><br><span class="line">53</span><br><span class="line">54</span><br><span class="line">55</span><br><span class="line">56</span><br><span class="line">57</span><br><span class="line">58</span><br><span class="line">59</span><br><span class="line">60</span><br><span class="line">61</span><br><span class="line">62</span><br><span class="line">63</span><br><span class="line">64</span><br><span class="line">65</span><br><span class="line">66</span><br><span class="line">67</span><br><span class="line">68</span><br><span class="line">69</span><br><span class="line">70</span><br><span class="line">71</span><br><span class="line">72</span><br><span class="line">73</span><br><span class="line">74</span><br><span class="line">75</span><br><span class="line">76</span><br><span class="line">77</span><br><span class="line">78</span><br><span class="line">79</span><br><span class="line">80</span><br><span class="line">81</span><br><span class="line">82</span><br><span class="line">83</span><br><span class="line">84</span><br><span class="line">85</span><br><span class="line">86</span><br><span class="line">87</span><br><span class="line">88</span><br><span class="line">89</span><br><span class="line">90</span><br><span class="line">91</span><br><span class="line">92</span><br><span class="line">93</span><br><span class="line">94</span><br><span class="line">95</span><br><span class="line">96</span><br><span class="line">97</span><br><span class="line">98</span><br><span class="line">99</span><br><span class="line">100</span><br><span class="line">101</span><br><span class="line">102</span><br><span class="line">103</span><br><span class="line">104</span><br><span class="line">105</span><br><span class="line">106</span><br><span class="line">107</span><br><span class="line">108</span><br><span class="line">109</span><br><span class="line">110</span><br><span class="line">111</span><br><span class="line">112</span><br><span class="line">113</span><br><span class="line">114</span><br><span class="line">115</span><br><span class="line">116</span><br><span class="line">117</span><br><span class="line">118</span><br><span class="line">119</span><br><span class="line">120</span><br><span class="line">121</span><br><span class="line">122</span><br><span class="line">123</span><br><span class="line">124</span><br><span class="line">125</span><br><span class="line">126</span><br><span class="line">127</span><br><span class="line">128</span><br><span class="line">129</span><br><span class="line">130</span><br><span class="line">131</span><br><span class="line">132</span><br><span class="line">133</span><br><span class="line">134</span><br><span class="line">135</span><br><span class="line">136</span><br><span class="line">137</span><br><span class="line">138</span><br><span class="line">139</span><br><span class="line">140</span><br><span class="line">141</span><br><span class="line">142</span><br><span class="line">143</span><br><span class="line">144</span><br><span class="line">145</span><br><span class="line">146</span><br><span class="line">147</span><br><span class="line">148</span><br><span class="line">149</span><br><span class="line">150</span><br><span class="line">151</span><br><span class="line">152</span><br><span class="line">153</span><br><span class="line">154</span><br><span class="line">155</span><br><span class="line">156</span><br><span class="line">157</span><br><span class="line">158</span><br><span class="line">159</span><br><span class="line">160</span><br><span class="line">161</span><br><span class="line">162</span><br><span class="line">163</span><br><span class="line">164</span><br><span class="line">165</span><br><span class="line">166</span><br><span class="line">167</span><br><span class="line">168</span><br><span class="line">169</span><br><span class="line">170</span><br><span class="line">171</span><br><span class="line">172</span><br><span class="line">173</span><br><span class="line">174</span><br><span class="line">175</span><br><span class="line">176</span><br><span class="line">177</span><br><span class="line">178</span><br><span class="line">179</span><br><span class="line">180</span><br><span class="line">181</span><br><span class="line">182</span><br><span class="line">183</span><br><span class="line">184</span><br><span class="line">185</span><br><span class="line">186</span><br><span class="line">187</span><br><span class="line">188</span><br><span class="line">189</span><br><span class="line">190</span><br><span class="line">191</span><br><span class="line">192</span><br><span class="line">193</span><br><span class="line">194</span><br><span class="line">195</span><br><span class="line">196</span><br><span class="line">197</span><br><span class="line">198</span><br><span class="line">199</span><br><span class="line">200</span><br><span class="line">201</span><br><span class="line">202</span><br><span class="line">203</span><br><span class="line">204</span><br><span class="line">205</span><br><span class="line">206</span><br><span class="line">207</span><br><span class="line">208</span><br><span class="line">209</span><br><span class="line">210</span><br><span class="line">211</span><br><span class="line">212</span><br><span class="line">213</span><br><span class="line">214</span><br><span class="line">215</span><br><span class="line">216</span><br><span class="line">217</span><br><span class="line">218</span><br><span class="line">219</span><br><span class="line">220</span><br><span class="line">221</span><br><span class="line">222</span><br><span class="line">223</span><br><span class="line">224</span><br><span class="line">225</span><br><span class="line">226</span><br><span class="line">227</span><br><span class="line">228</span><br><span class="line">229</span><br><span class="line">230</span><br><span class="line">231</span><br><span class="line">232</span><br><span class="line">233</span><br><span class="line">234</span><br><span class="line">235</span><br><span class="line">236</span><br><span class="line">237</span><br><span class="line">238</span><br><span class="line">239</span><br><span class="line">240</span><br><span class="line">241</span><br><span class="line">242</span><br><span class="line">243</span><br><span class="line">244</span><br><span class="line">245</span><br><span class="line">246</span><br><span class="line">247</span><br><span class="line">248</span><br><span class="line">249</span><br><span class="line">250</span><br><span class="line">251</span><br><span class="line">252</span><br><span class="line">253</span><br><span class="line">254</span><br><span class="line">255</span><br><span class="line">256</span><br><span class="line">257</span><br><span class="line">258</span><br><span class="line">259</span><br><span class="line">260</span><br><span class="line">261</span><br><span class="line">262</span><br><span class="line">263</span><br><span class="line">264</span><br><span class="line">265</span><br><span class="line">266</span><br><span class="line">267</span><br><span class="line">268</span><br><span class="line">269</span><br><span class="line">270</span><br><span class="line">271</span><br><span class="line">272</span><br><span class="line">273</span><br><span class="line">274</span><br><span class="line">275</span><br><span class="line">276</span><br><span class="line">277</span><br><span class="line">278</span><br><span class="line">279</span><br><span class="line">280</span><br><span class="line">281</span><br><span class="line">282</span><br><span class="line">283</span><br><span class="line">284</span><br><span class="line">285</span><br><span class="line">286</span><br><span class="line">287</span><br><span class="line">288</span><br><span class="line">289</span><br><span class="line">290</span><br><span class="line">291</span><br><span class="line">292</span><br><span class="line">293</span><br><span class="line">294</span><br><span class="line">295</span><br><span class="line">296</span><br><span class="line">297</span><br><span class="line">298</span><br><span class="line">299</span><br><span class="line">300</span><br><span class="line">301</span><br><span class="line">302</span><br><span class="line">303</span><br><span class="line">304</span><br><span class="line">305</span><br><span class="line">306</span><br><span class="line">307</span><br><span class="line">308</span><br><span class="line">309</span><br><span class="line">310</span><br><span class="line">311</span><br><span class="line">312</span><br><span class="line">313</span><br><span class="line">314</span><br><span class="line">315</span><br><span class="line">316</span><br><span class="line">317</span><br><span class="line">318</span><br><span class="line">319</span><br><span class="line">320</span><br><span class="line">321</span><br><span class="line">322</span><br><span class="line">323</span><br><span class="line">324</span><br><span class="line">325</span><br><span class="line">326</span><br><span class="line">327</span><br><span class="line">328</span><br><span class="line">329</span><br><span class="line">330</span><br><span class="line">331</span><br><span class="line">332</span><br><span class="line">333</span><br><span class="line">334</span><br><span class="line">335</span><br><span class="line">336</span><br><span class="line">337</span><br><span class="line">338</span><br><span class="line">339</span><br><span class="line">340</span><br><span class="line">341</span><br><span class="line">342</span><br><span class="line">343</span><br><span class="line">344</span><br><span class="line">345</span><br><span class="line">346</span><br><span class="line">347</span><br><span class="line">348</span><br><span class="line">349</span><br><span class="line">350</span><br><span class="line">351</span><br><span class="line">352</span><br><span class="line">353</span><br><span class="line">354</span><br><span class="line">355</span><br><span class="line">356</span><br><span class="line">357</span><br><span class="line">358</span><br><span class="line">359</span><br><span class="line">360</span><br><span class="line">361</span><br><span class="line">362</span><br><span class="line">363</span><br><span class="line">364</span><br><span class="line">365</span><br><span class="line">366</span><br><span class="line">367</span><br><span class="line">368</span><br><span class="line">369</span><br><span class="line">370</span><br><span class="line">371</span><br><span class="line">372</span><br><span class="line">373</span><br><span class="line">374</span><br><span class="line">375</span><br><span class="line">376</span><br><span class="line">377</span><br><span class="line">378</span><br><span class="line">379</span><br><span class="line">380</span><br><span class="line">381</span><br><span class="line">382</span><br><span class="line">383</span><br><span class="line">384</span><br><span class="line">385</span><br><span class="line">386</span><br><span class="line">387</span><br><span class="line">388</span><br><span class="line">389</span><br><span class="line">390</span><br><span class="line">391</span><br><span class="line">392</span><br><span class="line">393</span><br><span class="line">394</span><br><span class="line">395</span><br><span class="line">396</span><br><span class="line">397</span><br><span class="line">398</span><br><span class="line">399</span><br><span class="line">400</span><br><span class="line">401</span><br><span class="line">402</span><br><span class="line">403</span><br><span class="line">404</span><br><span class="line">405</span><br><span class="line">406</span><br><span class="line">407</span><br><span class="line">408</span><br><span class="line">409</span><br><span class="line">410</span><br><span class="line">411</span><br><span class="line">412</span><br><span class="line">413</span><br><span class="line">414</span><br><span class="line">415</span><br><span class="line">416</span><br><span class="line">417</span><br><span class="line">418</span><br><span class="line">419</span><br><span class="line">420</span><br><span class="line">421</span><br></pre></td><td class="code"><pre><span class="line">#!&#x2F;usr&#x2F;bin&#x2F;env bash</span><br><span class="line"></span><br><span class="line">set -o errexit</span><br><span class="line">set -o pipefail</span><br><span class="line"># set -o xtrace</span><br><span class="line"></span><br><span class="line"># set output color</span><br><span class="line">NC&#x3D;&#39;\033[0m&#39;</span><br><span class="line">RED&#x3D;&#39;\033[31m&#39;</span><br><span class="line">GREEN&#x3D;&#39;\033[32m&#39;</span><br><span class="line">YELLOW&#x3D;&#39;\033[33m&#39;</span><br><span class="line">BLUE&#x3D;&#39;\033[34m&#39;</span><br><span class="line"></span><br><span class="line">log::err() &#123;</span><br><span class="line">  printf &quot;[$(date +&#39;%Y-%m-%dT%H:%M:%S.%2N%z&#39;)][$&#123;RED&#125;ERROR$&#123;NC&#125;] %b\n&quot; &quot;$@&quot;</span><br><span class="line">&#125;</span><br><span class="line"></span><br><span class="line">log::info() &#123;</span><br><span class="line">  printf &quot;[$(date +&#39;%Y-%m-%dT%H:%M:%S.%2N%z&#39;)][INFO] %b\n&quot; &quot;$@&quot;</span><br><span class="line">&#125;</span><br><span class="line"></span><br><span class="line">log::warning() &#123;</span><br><span class="line">  printf &quot;[$(date +&#39;%Y-%m-%dT%H:%M:%S.%2N%z&#39;)][$&#123;YELLOW&#125;WARNING$&#123;NC&#125;] \033[0m%b\n&quot; &quot;$@&quot;</span><br><span class="line">&#125;</span><br><span class="line"></span><br><span class="line">check_file() &#123;</span><br><span class="line">  if [[ ! -r $&#123;1&#125; ]]; then</span><br><span class="line">    log::err &quot;can not find $&#123;1&#125;&quot;</span><br><span class="line">    exit 1</span><br><span class="line">  fi</span><br><span class="line">&#125;</span><br><span class="line"></span><br><span class="line"># get x509v3 subject alternative name from the old certificate</span><br><span class="line">cert::get_subject_alt_name() &#123;</span><br><span class="line">  local cert&#x3D;$&#123;1&#125;.crt</span><br><span class="line">  local alt_name</span><br><span class="line"></span><br><span class="line">  check_file &quot;$&#123;cert&#125;&quot;</span><br><span class="line">  alt_name&#x3D;$(openssl x509 -text -noout -in &quot;$&#123;cert&#125;&quot; | grep -A1 &#39;Alternative&#39; | tail -n1 | sed &#39;s&#x2F;[[:space:]]*Address&#x2F;&#x2F;g&#39;)</span><br><span class="line">  printf &quot;%s\n&quot; &quot;$&#123;alt_name&#125;&quot;</span><br><span class="line">&#125;</span><br><span class="line"></span><br><span class="line"># get subject from the old certificate</span><br><span class="line">cert::get_subj() &#123;</span><br><span class="line">  local cert&#x3D;$&#123;1&#125;.crt</span><br><span class="line">  local subj</span><br><span class="line"></span><br><span class="line">  check_file &quot;$&#123;cert&#125;&quot;</span><br><span class="line">  subj&#x3D;$(openssl x509 -text -noout -in &quot;$&#123;cert&#125;&quot; | grep &quot;Subject:&quot; | sed &#39;s&#x2F;Subject:&#x2F;\&#x2F;&#x2F;g;s&#x2F;\,&#x2F;\&#x2F;&#x2F;;s&#x2F;[[:space:]]&#x2F;&#x2F;g&#39;)</span><br><span class="line">  printf &quot;%s\n&quot; &quot;$&#123;subj&#125;&quot;</span><br><span class="line">&#125;</span><br><span class="line"></span><br><span class="line">cert::backup_file() &#123;</span><br><span class="line">  local file&#x3D;$&#123;1&#125;</span><br><span class="line">  if [[ ! -e $&#123;file&#125;.old-$(date +%Y%m%d) ]]; then</span><br><span class="line">    cp -rp &quot;$&#123;file&#125;&quot; &quot;$&#123;file&#125;.old-$(date +%Y%m%d)&quot;</span><br><span class="line">    log::info &quot;backup $&#123;file&#125; to $&#123;file&#125;.old-$(date +%Y%m%d)&quot;</span><br><span class="line">  else</span><br><span class="line">    log::warning &quot;does not backup, $&#123;file&#125;.old-$(date +%Y%m%d) already exists&quot;</span><br><span class="line">  fi</span><br><span class="line">&#125;</span><br><span class="line"></span><br><span class="line"># check certificate expiration</span><br><span class="line">cert::check_cert_expiration() &#123;</span><br><span class="line">  local cert&#x3D;$&#123;1&#125;.crt</span><br><span class="line">  local cert_expires</span><br><span class="line"></span><br><span class="line">  cert_expires&#x3D;$(openssl x509 -text -noout -in &quot;$&#123;cert&#125;&quot; | awk -F &quot;: &quot; &#39;&#x2F;Not After&#x2F;&#123;print$2&#125;&#39;)</span><br><span class="line">  printf &quot;%s\n&quot; &quot;$&#123;cert_expires&#125;&quot;</span><br><span class="line">&#125;</span><br><span class="line"></span><br><span class="line"># check kubeconfig expiration</span><br><span class="line">cert::check_kubeconfig_expiration() &#123;</span><br><span class="line">  local config&#x3D;$&#123;1&#125;.conf</span><br><span class="line">  local cert</span><br><span class="line">  local cert_expires</span><br><span class="line"></span><br><span class="line">  cert&#x3D;$(grep &quot;client-certificate-data&quot; &quot;$&#123;config&#125;&quot; | awk &#39;&#123;print$2&#125;&#39; | base64 -d)</span><br><span class="line">  cert_expires&#x3D;$(openssl x509 -text -noout -in &lt;(printf &quot;%s&quot; &quot;$&#123;cert&#125;&quot;) | awk -F &quot;: &quot; &#39;&#x2F;Not After&#x2F;&#123;print$2&#125;&#39;)</span><br><span class="line">  printf &quot;%s\n&quot; &quot;$&#123;cert_expires&#125;&quot;</span><br><span class="line">&#125;</span><br><span class="line"></span><br><span class="line"># check etcd certificates expiration</span><br><span class="line">cert::check_etcd_certs_expiration() &#123;</span><br><span class="line">  local cert</span><br><span class="line">  local certs</span><br><span class="line"></span><br><span class="line">  certs&#x3D;(</span><br><span class="line">    &quot;$&#123;ETCD_CERT_CA&#125;&quot;</span><br><span class="line">    &quot;$&#123;ETCD_CERT_SERVER&#125;&quot;</span><br><span class="line">    &quot;$&#123;ETCD_CERT_PEER&#125;&quot;</span><br><span class="line">    &quot;$&#123;ETCD_CERT_HEALTHCHECK_CLIENT&#125;&quot;</span><br><span class="line">    &quot;$&#123;ETCD_CERT_APISERVER_ETCD_CLIENT&#125;&quot;</span><br><span class="line">  )</span><br><span class="line"></span><br><span class="line">  for cert in &quot;$&#123;certs[@]&#125;&quot;; do</span><br><span class="line">    if [[ ! -r $&#123;cert&#125; ]]; then</span><br><span class="line">      printf &quot;%-50s%-30s\n&quot; &quot;$&#123;cert&#125;.crt&quot; &quot;$(cert::check_cert_expiration &quot;$&#123;cert&#125;&quot;)&quot;</span><br><span class="line">    fi</span><br><span class="line">  done</span><br><span class="line">&#125;</span><br><span class="line"></span><br><span class="line"># check master certificates expiration</span><br><span class="line">cert::check_master_certs_expiration() &#123;</span><br><span class="line">  local certs</span><br><span class="line">  local kubeconfs</span><br><span class="line">  local cert</span><br><span class="line">  local conf</span><br><span class="line"></span><br><span class="line">  certs&#x3D;(</span><br><span class="line">    &quot;$&#123;CERT_CA&#125;&quot;</span><br><span class="line">    &quot;$&#123;CERT_APISERVER&#125;&quot;</span><br><span class="line">    &quot;$&#123;CERT_APISERVER_KUBELET_CLIENT&#125;&quot;</span><br><span class="line">    &quot;$&#123;FRONT_PROXY_CA&#125;&quot;</span><br><span class="line">    &quot;$&#123;FRONT_PROXY_CLIENT&#125;&quot;</span><br><span class="line">  )</span><br><span class="line"></span><br><span class="line">  kubeconfs&#x3D;(</span><br><span class="line">    &quot;$&#123;CONF_CONTROLLER_MANAGER&#125;&quot;</span><br><span class="line">    &quot;$&#123;CONF_SCHEDULER&#125;&quot;</span><br><span class="line">    &quot;$&#123;CONF_ADMIN&#125;&quot;</span><br><span class="line">  )</span><br><span class="line"></span><br><span class="line">  printf &quot;%-50s%-30s\n&quot; &quot;CERTIFICATE&quot; &quot;EXPIRES&quot;</span><br><span class="line"></span><br><span class="line">  for conf in &quot;$&#123;kubeconfs[@]&#125;&quot;; do</span><br><span class="line">    if [[ ! -r $&#123;conf&#125; ]]; then</span><br><span class="line">      printf &quot;%-50s%-30s\n&quot; &quot;$&#123;conf&#125;.config&quot; &quot;$(cert::check_kubeconfig_expiration &quot;$&#123;conf&#125;&quot;)&quot;</span><br><span class="line">    fi</span><br><span class="line">  done</span><br><span class="line"></span><br><span class="line">  for cert in &quot;$&#123;certs[@]&#125;&quot;; do</span><br><span class="line">    if [[ ! -r $&#123;cert&#125; ]]; then</span><br><span class="line">      printf &quot;%-50s%-30s\n&quot; &quot;$&#123;cert&#125;.crt&quot; &quot;$(cert::check_cert_expiration &quot;$&#123;cert&#125;&quot;)&quot;</span><br><span class="line">    fi</span><br><span class="line">  done</span><br><span class="line">&#125;</span><br><span class="line"></span><br><span class="line"># check all certificates expiration</span><br><span class="line">cert::check_all_expiration() &#123;</span><br><span class="line">  cert::check_master_certs_expiration</span><br><span class="line">  cert::check_etcd_certs_expiration</span><br><span class="line">&#125;</span><br><span class="line"></span><br><span class="line"># generate certificate whit client, server or peer</span><br><span class="line"># Args:</span><br><span class="line">#   $1 (the name of certificate)</span><br><span class="line">#   $2 (the type of certificate, must be one of client, server, peer)</span><br><span class="line">#   $3 (the subject of certificates)</span><br><span class="line">#   $4 (the validity of certificates) (days)</span><br><span class="line">#   $5 (the name of ca)</span><br><span class="line">#   $6 (the x509v3 subject alternative name of certificate when the type of certificate is server or peer)</span><br><span class="line">cert::gen_cert() &#123;</span><br><span class="line">  local cert_name&#x3D;$&#123;1&#125;</span><br><span class="line">  local cert_type&#x3D;$&#123;2&#125;</span><br><span class="line">  local subj&#x3D;$&#123;3&#125;</span><br><span class="line">  local cert_days&#x3D;$&#123;4&#125;</span><br><span class="line">  local ca_name&#x3D;$&#123;5&#125;</span><br><span class="line">  local alt_name&#x3D;$&#123;6&#125;</span><br><span class="line">  local ca_cert&#x3D;$&#123;ca_name&#125;.crt</span><br><span class="line">  local ca_key&#x3D;$&#123;ca_name&#125;.key</span><br><span class="line">  local cert&#x3D;$&#123;cert_name&#125;.crt</span><br><span class="line">  local key&#x3D;$&#123;cert_name&#125;.key</span><br><span class="line">  local csr&#x3D;$&#123;cert_name&#125;.csr</span><br><span class="line">  local common_csr_conf&#x3D;&#39;distinguished_name &#x3D; dn\n[dn]\n[v3_ext]\nkeyUsage &#x3D; critical, digitalSignature, keyEncipherment\n&#39;</span><br><span class="line"></span><br><span class="line">  for file in &quot;$&#123;ca_cert&#125;&quot; &quot;$&#123;ca_key&#125;&quot; &quot;$&#123;cert&#125;&quot; &quot;$&#123;key&#125;&quot;; do</span><br><span class="line">    check_file &quot;$&#123;file&#125;&quot;</span><br><span class="line">  done</span><br><span class="line"></span><br><span class="line">  case &quot;$&#123;cert_type&#125;&quot; in</span><br><span class="line">  client)</span><br><span class="line">    csr_conf&#x3D;$(printf &quot;%bextendedKeyUsage &#x3D; clientAuth\n&quot; &quot;$&#123;common_csr_conf&#125;&quot;)</span><br><span class="line">    ;;</span><br><span class="line">  server)</span><br><span class="line">    csr_conf&#x3D;$(printf &quot;%bextendedKeyUsage &#x3D; serverAuth\nsubjectAltName &#x3D; %b\n&quot; &quot;$&#123;common_csr_conf&#125;&quot; &quot;$&#123;alt_name&#125;&quot;)</span><br><span class="line">    ;;</span><br><span class="line">  peer)</span><br><span class="line">    csr_conf&#x3D;$(printf &quot;%bextendedKeyUsage &#x3D; serverAuth, clientAuth\nsubjectAltName &#x3D; %b\n&quot; &quot;$&#123;common_csr_conf&#125;&quot; &quot;$&#123;alt_name&#125;&quot;)</span><br><span class="line">    ;;</span><br><span class="line">  *)</span><br><span class="line">    log::err &quot;unknow, unsupported certs type: $&#123;YELLOW&#125;$&#123;cert_type&#125;$&#123;NC&#125;, supported type: client, server, peer&quot;</span><br><span class="line">    exit 1</span><br><span class="line">    ;;</span><br><span class="line">  esac</span><br><span class="line"></span><br><span class="line">  # gen csr</span><br><span class="line">  openssl req -new -key &quot;$&#123;key&#125;&quot; -subj &quot;$&#123;subj&#125;&quot; -reqexts v3_ext \</span><br><span class="line">    -config &lt;(printf &quot;%b&quot; &quot;$&#123;csr_conf&#125;&quot;) \</span><br><span class="line">    -out &quot;$&#123;csr&#125;&quot; &gt;&#x2F;dev&#x2F;null 2&gt;&amp;1</span><br><span class="line">  # gen cert</span><br><span class="line">  openssl x509 -in &quot;$&#123;csr&#125;&quot; -req -CA &quot;$&#123;ca_cert&#125;&quot; -CAkey &quot;$&#123;ca_key&#125;&quot; -CAcreateserial -extensions v3_ext \</span><br><span class="line">    -extfile &lt;(printf &quot;%b&quot; &quot;$&#123;csr_conf&#125;&quot;) \</span><br><span class="line">    -days &quot;$&#123;cert_days&#125;&quot; -out &quot;$&#123;cert&#125;&quot; &gt;&#x2F;dev&#x2F;null 2&gt;&amp;1</span><br><span class="line"></span><br><span class="line">  rm -f &quot;$&#123;csr&#125;&quot;</span><br><span class="line">&#125;</span><br><span class="line"></span><br><span class="line">cert::update_kubeconf() &#123;</span><br><span class="line">  local cert_name&#x3D;$&#123;1&#125;</span><br><span class="line">  local kubeconf_file&#x3D;$&#123;cert_name&#125;.conf</span><br><span class="line">  local cert&#x3D;$&#123;cert_name&#125;.crt</span><br><span class="line">  local key&#x3D;$&#123;cert_name&#125;.key</span><br><span class="line">  local subj</span><br><span class="line">  local cert_base64</span><br><span class="line"></span><br><span class="line">  check_file &quot;$&#123;kubeconf_file&#125;&quot;</span><br><span class="line">  # get the key from the old kubeconf</span><br><span class="line">  grep &quot;client-key-data&quot; &quot;$&#123;kubeconf_file&#125;&quot; | awk &#39;&#123;print$2&#125;&#39; | base64 -d &gt;&quot;$&#123;key&#125;&quot;</span><br><span class="line">  # get the old certificate from the old kubeconf</span><br><span class="line">  grep &quot;client-certificate-data&quot; &quot;$&#123;kubeconf_file&#125;&quot; | awk &#39;&#123;print$2&#125;&#39; | base64 -d &gt;&quot;$&#123;cert&#125;&quot;</span><br><span class="line">  # get subject from the old certificate</span><br><span class="line">  subj&#x3D;$(cert::get_subj &quot;$&#123;cert_name&#125;&quot;)</span><br><span class="line">  cert::gen_cert &quot;$&#123;cert_name&#125;&quot; &quot;client&quot; &quot;$&#123;subj&#125;&quot; &quot;$&#123;CERT_DAYS&#125;&quot; &quot;$&#123;CERT_CA&#125;&quot;</span><br><span class="line">  # get certificate base64 code</span><br><span class="line">  cert_base64&#x3D;$(base64 -w 0 &quot;$&#123;cert&#125;&quot;)</span><br><span class="line"></span><br><span class="line">  # set certificate base64 code to kubeconf</span><br><span class="line">  sed -i &#39;s&#x2F;client-certificate-data:.*&#x2F;client-certificate-data: &#39;&quot;$&#123;cert_base64&#125;&quot;&#39;&#x2F;g&#39; &quot;$&#123;kubeconf_file&#125;&quot;</span><br><span class="line"></span><br><span class="line">  rm -f &quot;$&#123;cert&#125;&quot;</span><br><span class="line">  rm -f &quot;$&#123;key&#125;&quot;</span><br><span class="line">&#125;</span><br><span class="line"></span><br><span class="line">cert::update_etcd_cert() &#123;</span><br><span class="line">  local subj</span><br><span class="line">  local subject_alt_name</span><br><span class="line">  local cert</span><br><span class="line"></span><br><span class="line">  # generate etcd server,peer certificate</span><br><span class="line">  # &#x2F;etc&#x2F;kubernetes&#x2F;pki&#x2F;etcd&#x2F;server</span><br><span class="line">  # &#x2F;etc&#x2F;kubernetes&#x2F;pki&#x2F;etcd&#x2F;peer</span><br><span class="line">  for cert in $&#123;ETCD_CERT_SERVER&#125; $&#123;ETCD_CERT_PEER&#125;; do</span><br><span class="line">    subj&#x3D;$(cert::get_subj &quot;$&#123;cert&#125;&quot;)</span><br><span class="line">    subject_alt_name&#x3D;$(cert::get_subject_alt_name &quot;$&#123;cert&#125;&quot;)</span><br><span class="line">    cert::gen_cert &quot;$&#123;cert&#125;&quot; &quot;peer&quot; &quot;$&#123;subj&#125;&quot; &quot;$&#123;CERT_DAYS&#125;&quot; &quot;$&#123;ETCD_CERT_CA&#125;&quot; &quot;$&#123;subject_alt_name&#125;&quot;</span><br><span class="line">    log::info &quot;$&#123;GREEN&#125;updated $&#123;BLUE&#125;$&#123;cert&#125;.conf$&#123;NC&#125;&quot;</span><br><span class="line">  done</span><br><span class="line"></span><br><span class="line">  # generate etcd healthcheck-client,apiserver-etcd-client certificate</span><br><span class="line">  # &#x2F;etc&#x2F;kubernetes&#x2F;pki&#x2F;etcd&#x2F;healthcheck-client</span><br><span class="line">  # &#x2F;etc&#x2F;kubernetes&#x2F;pki&#x2F;apiserver-etcd-client</span><br><span class="line">  for cert in $&#123;ETCD_CERT_HEALTHCHECK_CLIENT&#125; $&#123;ETCD_CERT_APISERVER_ETCD_CLIENT&#125;; do</span><br><span class="line">    subj&#x3D;$(cert::get_subj &quot;$&#123;cert&#125;&quot;)</span><br><span class="line">    cert::gen_cert &quot;$&#123;cert&#125;&quot; &quot;client&quot; &quot;$&#123;subj&#125;&quot; &quot;$&#123;CERT_DAYS&#125;&quot; &quot;$&#123;ETCD_CERT_CA&#125;&quot;</span><br><span class="line">    log::info &quot;$&#123;GREEN&#125;updated $&#123;BLUE&#125;$&#123;cert&#125;.conf$&#123;NC&#125;&quot;</span><br><span class="line">  done</span><br><span class="line"></span><br><span class="line">  # restart etcd</span><br><span class="line">  docker ps | awk &#39;&#x2F;k8s_etcd&#x2F;&#123;print$1&#125;&#39; | xargs -r -I &#39;&#123;&#125;&#39; docker restart &#123;&#125; &gt;&#x2F;dev&#x2F;null 2&gt;&amp;1 || true</span><br><span class="line">  log::info &quot;restarted etcd&quot;</span><br><span class="line">&#125;</span><br><span class="line"></span><br><span class="line">cert::update_master_cert() &#123;</span><br><span class="line">  local subj</span><br><span class="line">  local subject_alt_name</span><br><span class="line">  local conf</span><br><span class="line"></span><br><span class="line">  # generate apiserver server certificate</span><br><span class="line">  # &#x2F;etc&#x2F;kubernetes&#x2F;pki&#x2F;apiserver</span><br><span class="line">  subj&#x3D;$(cert::get_subj &quot;$&#123;CERT_APISERVER&#125;&quot;)</span><br><span class="line">  subject_alt_name&#x3D;$(cert::get_subject_alt_name &quot;$&#123;CERT_APISERVER&#125;&quot;)</span><br><span class="line">  cert::gen_cert &quot;$&#123;CERT_APISERVER&#125;&quot; &quot;server&quot; &quot;$&#123;subj&#125;&quot; &quot;$&#123;CERT_DAYS&#125;&quot; &quot;$&#123;CERT_CA&#125;&quot; &quot;$&#123;subject_alt_name&#125;&quot;</span><br><span class="line">  log::info &quot;$&#123;GREEN&#125;updated $&#123;BLUE&#125;$&#123;CERT_APISERVER&#125;.crt$&#123;NC&#125;&quot;</span><br><span class="line"></span><br><span class="line">  # generate apiserver-kubelet-client certificate</span><br><span class="line">  # &#x2F;etc&#x2F;kubernetes&#x2F;pki&#x2F;apiserver-kubelet-client</span><br><span class="line">  subj&#x3D;$(cert::get_subj &quot;$&#123;CERT_APISERVER_KUBELET_CLIENT&#125;&quot;)</span><br><span class="line">  cert::gen_cert &quot;$&#123;CERT_APISERVER_KUBELET_CLIENT&#125;&quot; &quot;client&quot; &quot;$&#123;subj&#125;&quot; &quot;$&#123;CERT_DAYS&#125;&quot; &quot;$&#123;CERT_CA&#125;&quot;</span><br><span class="line">  log::info &quot;$&#123;GREEN&#125;updated $&#123;BLUE&#125;$&#123;CERT_APISERVER_KUBELET_CLIENT&#125;.crt$&#123;NC&#125;&quot;</span><br><span class="line"></span><br><span class="line">  # generate kubeconf for controller-manager,scheduler and kubelet</span><br><span class="line">  # &#x2F;etc&#x2F;kubernetes&#x2F;controller-manager,scheduler,admin,kubelet.conf</span><br><span class="line">  for conf in $&#123;CONF_CONTROLLER_MANAGER&#125; $&#123;CONF_SCHEDULER&#125; $&#123;CONF_ADMIN&#125; $&#123;CONF_KUBELET&#125;; do</span><br><span class="line">    if [[ $&#123;conf##*&#x2F;&#125; &#x3D;&#x3D; &quot;kubelet&quot; ]]; then</span><br><span class="line">      # https:&#x2F;&#x2F;github.com&#x2F;kubernetes&#x2F;kubeadm&#x2F;issues&#x2F;1753</span><br><span class="line">      set +e</span><br><span class="line">      grep kubelet-client-current.pem &#x2F;etc&#x2F;kubernetes&#x2F;kubelet.conf &gt;&#x2F;dev&#x2F;null 2&gt;&amp;1</span><br><span class="line">      kubelet_cert_auto_update&#x3D;$?</span><br><span class="line">      set -e</span><br><span class="line">      if [[ &quot;$kubelet_cert_auto_update&quot; &#x3D;&#x3D; &quot;0&quot; ]]; then</span><br><span class="line">        log::info &quot;does not need to update kubelet.conf&quot;</span><br><span class="line">        continue</span><br><span class="line">      fi</span><br><span class="line">    fi</span><br><span class="line"></span><br><span class="line">    # update kubeconf</span><br><span class="line">    cert::update_kubeconf &quot;$&#123;conf&#125;&quot;</span><br><span class="line">    log::info &quot;$&#123;GREEN&#125;updated $&#123;BLUE&#125;$&#123;conf&#125;.conf$&#123;NC&#125;&quot;</span><br><span class="line"></span><br><span class="line">    # copy admin.conf to $&#123;HOME&#125;&#x2F;.kube&#x2F;config</span><br><span class="line">    if [[ $&#123;conf##*&#x2F;&#125; &#x3D;&#x3D; &quot;admin&quot; ]]; then</span><br><span class="line">      mkdir -p &quot;$&#123;HOME&#125;&#x2F;.kube&quot;</span><br><span class="line">      local config&#x3D;$&#123;HOME&#125;&#x2F;.kube&#x2F;config</span><br><span class="line">      local config_backup</span><br><span class="line">      config_backup&#x3D;$&#123;HOME&#125;&#x2F;.kube&#x2F;config.old-$(date +%Y%m%d)</span><br><span class="line">      if [[ -f $&#123;config&#125; ]] &amp;&amp; [[ ! -f $&#123;config_backup&#125; ]]; then</span><br><span class="line">        cp -fp &quot;$&#123;config&#125;&quot; &quot;$&#123;config_backup&#125;&quot;</span><br><span class="line">        log::info &quot;backup $&#123;config&#125; to $&#123;config_backup&#125;&quot;</span><br><span class="line">      fi</span><br><span class="line">      cp -fp &quot;$&#123;conf&#125;.conf&quot; &quot;$&#123;HOME&#125;&#x2F;.kube&#x2F;config&quot;</span><br><span class="line">      log::info &quot;copy the admin.conf to $&#123;HOME&#125;&#x2F;.kube&#x2F;config&quot;</span><br><span class="line">    fi</span><br><span class="line">  done</span><br><span class="line"></span><br><span class="line">  # generate front-proxy-client certificate</span><br><span class="line">  # &#x2F;etc&#x2F;kubernetes&#x2F;pki&#x2F;front-proxy-client</span><br><span class="line">  subj&#x3D;$(cert::get_subj &quot;$&#123;FRONT_PROXY_CLIENT&#125;&quot;)</span><br><span class="line">  cert::gen_cert &quot;$&#123;FRONT_PROXY_CLIENT&#125;&quot; &quot;client&quot; &quot;$&#123;subj&#125;&quot; &quot;$&#123;CERT_DAYS&#125;&quot; &quot;$&#123;FRONT_PROXY_CA&#125;&quot;</span><br><span class="line">  log::info &quot;$&#123;GREEN&#125;updated $&#123;BLUE&#125;$&#123;FRONT_PROXY_CLIENT&#125;.crt$&#123;NC&#125;&quot;</span><br><span class="line"></span><br><span class="line">  # restart apiserver, controller-manager, scheduler and kubelet</span><br><span class="line">  for item in &quot;apiserver&quot; &quot;controller-manager&quot; &quot;scheduler&quot;; do</span><br><span class="line">    docker ps | awk &#39;&#x2F;k8s_kube-&#39;$&#123;item&#125;&#39;&#x2F;&#123;print$1&#125;&#39; | xargs -r -I &#39;&#123;&#125;&#39; docker restart &#123;&#125; &gt;&#x2F;dev&#x2F;null 2&gt;&amp;1 || true</span><br><span class="line">    log::info &quot;restarted $&#123;item&#125;&quot;</span><br><span class="line">  done</span><br><span class="line">  systemctl restart kubelet || true</span><br><span class="line">  log::info &quot;restarted kubelet&quot;</span><br><span class="line">&#125;</span><br><span class="line"></span><br><span class="line">main() &#123;</span><br><span class="line">  local node_type&#x3D;$1</span><br><span class="line"></span><br><span class="line">  CERT_DAYS&#x3D;36500</span><br><span class="line"></span><br><span class="line">  KUBE_PATH&#x3D;&#x2F;etc&#x2F;kubernetes</span><br><span class="line">  PKI_PATH&#x3D;$&#123;KUBE_PATH&#125;&#x2F;pki</span><br><span class="line"></span><br><span class="line">  # master certificates path</span><br><span class="line">  # apiserver</span><br><span class="line">  CERT_CA&#x3D;$&#123;PKI_PATH&#125;&#x2F;ca</span><br><span class="line">  CERT_APISERVER&#x3D;$&#123;PKI_PATH&#125;&#x2F;apiserver</span><br><span class="line">  CERT_APISERVER_KUBELET_CLIENT&#x3D;$&#123;PKI_PATH&#125;&#x2F;apiserver-kubelet-client</span><br><span class="line">  CONF_CONTROLLER_MANAGER&#x3D;$&#123;KUBE_PATH&#125;&#x2F;controller-manager</span><br><span class="line">  CONF_SCHEDULER&#x3D;$&#123;KUBE_PATH&#125;&#x2F;scheduler</span><br><span class="line">  CONF_ADMIN&#x3D;$&#123;KUBE_PATH&#125;&#x2F;admin</span><br><span class="line">  CONF_KUBELET&#x3D;$&#123;KUBE_PATH&#125;&#x2F;kubelet</span><br><span class="line">  # front-proxy</span><br><span class="line">  FRONT_PROXY_CA&#x3D;$&#123;PKI_PATH&#125;&#x2F;front-proxy-ca</span><br><span class="line">  FRONT_PROXY_CLIENT&#x3D;$&#123;PKI_PATH&#125;&#x2F;front-proxy-client</span><br><span class="line"></span><br><span class="line">  # etcd certificates path</span><br><span class="line">  ETCD_CERT_CA&#x3D;$&#123;PKI_PATH&#125;&#x2F;etcd&#x2F;ca</span><br><span class="line">  ETCD_CERT_SERVER&#x3D;$&#123;PKI_PATH&#125;&#x2F;etcd&#x2F;server</span><br><span class="line">  ETCD_CERT_PEER&#x3D;$&#123;PKI_PATH&#125;&#x2F;etcd&#x2F;peer</span><br><span class="line">  ETCD_CERT_HEALTHCHECK_CLIENT&#x3D;$&#123;PKI_PATH&#125;&#x2F;etcd&#x2F;healthcheck-client</span><br><span class="line">  ETCD_CERT_APISERVER_ETCD_CLIENT&#x3D;$&#123;PKI_PATH&#125;&#x2F;apiserver-etcd-client</span><br><span class="line"></span><br><span class="line">  case $&#123;node_type&#125; in</span><br><span class="line">  # etcd)</span><br><span class="line">  # # update etcd certificates</span><br><span class="line">  #   cert::update_etcd_cert</span><br><span class="line">  # ;;</span><br><span class="line">  master)</span><br><span class="line">    # check certificates expiration</span><br><span class="line">    cert::check_master_certs_expiration</span><br><span class="line">    # backup $KUBE_PATH to $KUBE_PATH.old-$(date +%Y%m%d)</span><br><span class="line">    cert::backup_file &quot;$&#123;KUBE_PATH&#125;&quot;</span><br><span class="line">    # update master certificates and kubeconf</span><br><span class="line">    log::info &quot;$&#123;GREEN&#125;updating...$&#123;NC&#125;&quot;</span><br><span class="line">    cert::update_master_cert</span><br><span class="line">    log::info &quot;$&#123;GREEN&#125;done!!!$&#123;NC&#125;&quot;</span><br><span class="line">    # check certificates expiration after certificates updated</span><br><span class="line">    cert::check_master_certs_expiration</span><br><span class="line">    ;;</span><br><span class="line">  all)</span><br><span class="line">    # check certificates expiration</span><br><span class="line">    cert::check_all_expiration</span><br><span class="line">    # backup $KUBE_PATH to $KUBE_PATH.old-$(date +%Y%m%d)</span><br><span class="line">    cert::backup_file &quot;$&#123;KUBE_PATH&#125;&quot;</span><br><span class="line">    # update etcd certificates</span><br><span class="line">    log::info &quot;$&#123;GREEN&#125;updating...$&#123;NC&#125;&quot;</span><br><span class="line">    cert::update_etcd_cert</span><br><span class="line">    # update master certificates and kubeconf</span><br><span class="line">    cert::update_master_cert</span><br><span class="line">    log::info &quot;$&#123;GREEN&#125;done!!!$&#123;NC&#125;&quot;</span><br><span class="line">    # check certificates expiration after certificates updated</span><br><span class="line">    cert::check_all_expiration</span><br><span class="line">    ;;</span><br><span class="line">  check)</span><br><span class="line">    # check certificates expiration</span><br><span class="line">    cert::check_all_expiration</span><br><span class="line">    ;;</span><br><span class="line">  *)</span><br><span class="line">    log::err &quot;unknown, unsupported cert type: $&#123;node_type&#125;, supported type: \&quot;all\&quot;, \&quot;master\&quot;&quot;</span><br><span class="line">    printf &quot;Documentation: https:&#x2F;&#x2F;github.com&#x2F;yuyicai&#x2F;update-kube-cert</span><br><span class="line">  example:</span><br><span class="line">    &#39;\033[32m.&#x2F;update-kubeadm-cert.sh all\033[0m&#39; update all etcd certificates, master certificates and kubeconf</span><br><span class="line">      &#x2F;etc&#x2F;kubernetes</span><br><span class="line">      ├── admin.conf</span><br><span class="line">      ├── controller-manager.conf</span><br><span class="line">      ├── scheduler.conf</span><br><span class="line">      ├── kubelet.conf</span><br><span class="line">      └── pki</span><br><span class="line">          ├── apiserver.crt</span><br><span class="line">          ├── apiserver-etcd-client.crt</span><br><span class="line">          ├── apiserver-kubelet-client.crt</span><br><span class="line">          ├── front-proxy-client.crt</span><br><span class="line">          └── etcd</span><br><span class="line">              ├── healthcheck-client.crt</span><br><span class="line">              ├── peer.crt</span><br><span class="line">              └── server.crt</span><br><span class="line"></span><br><span class="line">    &#39;\033[32m.&#x2F;update-kubeadm-cert.sh master\033[0m&#39; update only master certificates and kubeconf</span><br><span class="line">      &#x2F;etc&#x2F;kubernetes</span><br><span class="line">      ├── admin.conf</span><br><span class="line">      ├── controller-manager.conf</span><br><span class="line">      ├── scheduler.conf</span><br><span class="line">      ├── kubelet.conf</span><br><span class="line">      └── pki</span><br><span class="line">          ├── apiserver.crt</span><br><span class="line">          ├── apiserver-kubelet-client.crt</span><br><span class="line">          └── front-proxy-client.crt</span><br><span class="line">&quot;</span><br><span class="line">    exit 1</span><br><span class="line">    ;;</span><br><span class="line">  esac</span><br><span class="line">&#125;</span><br><span class="line"></span><br><span class="line">main &quot;$@&quot;</span><br><span class="line"></span><br></pre></td></tr></table></figure></article><div class="post-copyright"><div class="post-copyright__author"><span class="post-copyright-meta">文章作者: </span><span class="post-copyright-info"><a href="mailto:undefined">ZuSir</a></span></div><div class="post-copyright__type"><span class="post-copyright-meta">文章链接: </span><span class="post-copyright-info"><a href="http://example.com/2021/11/03/ubeadm%E8%AF%81%E4%B9%A6%E7%BB%AD%E7%AD%BEjioaben/">http://example.com/2021/11/03/ubeadm%E8%AF%81%E4%B9%A6%E7%BB%AD%E7%AD%BEjioaben/</a></span></div><div class="post-copyright__notice"><span class="post-copyright-meta">版权声明: </span><span class="post-copyright-info">本博客所有文章除特别声明外，均采用 <a href="https://creativecommons.org/licenses/by-nc-sa/4.0/" target="_blank">CC BY-NC-SA 4.0</a> 许可协议。转载请注明来自 <a href="http://example.com" target="_blank">SeMaik</a>！</span></div></div><div class="tag_share"><div class="post-meta__tag-list"></div><div class="post_share"><div class="social-share" data-image="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" data-sites="facebook,twitter,wechat,weibo,qq"></div><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/social-share.js/dist/css/share.min.css" media="print" onload="this.media='all'"><script src="https://cdn.jsdelivr.net/npm/social-share.js/dist/js/social-share.min.js" defer></script></div></div><nav class="pagination-post" id="pagination"><div class="prev-post pull-left"><a href="/2021/11/03/%E5%A4%84%E7%90%86Ceph-OSD-Down/"><img class="prev-cover" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" onerror="onerror=null;src='/img/123.jpeg'" alt="cover of previous post"><div class="pagination-info"><div class="label">上一篇</div><div class="prev_info">处理Ceph OSD Down</div></div></a></div><div class="next-post pull-right"><a href="/2021/08/27/%E5%AE%B9%E5%99%A8%E6%8E%A2%E9%92%88/"><img class="next-cover" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" onerror="onerror=null;src='/img/123.jpeg'" alt="cover of next post"><div class="pagination-info"><div class="label">下一篇</div><div class="next_info">容器探针</div></div></a></div></nav></div><div class="aside-content" id="aside-content"><div class="card-widget card-info"><div class="card-info-avatar is-center"><img class="avatar-img" src="/img/123.jpeg" onerror="this.onerror=null;this.src='/img/123.jpeg'" alt="avatar"/><div class="author-info__name">ZuSir</div><div class="author-info__description">一个收藏回忆与分享技术的地方!</div></div><div class="card-info-data"><div class="card-info-data-item is-center"><a href="/archives/"><div class="headline">文章</div><div class="length-num">152</div></a></div><div class="card-info-data-item is-center"><a href="/categories/"><div class="headline">分类</div><div class="length-num">37</div></a></div></div></div><div class="card-widget card-announcement"><div class="item-headline"><i class="fas fa-bullhorn card-announcement-animation"></i><span>公告</span></div><div class="announcement_content">This is my Blog! <img src="https://ss0.bdstatic.com/70cFuHSh_Q1YnxGkpoWK1HF6hhy/it/u=3894415926,2787041726&fm=26&gp=0.jpg"></div></div><div class="sticky_layout"><div class="card-widget card-recent-post"><div class="item-headline"><i class="fas fa-history"></i><span>最新文章</span></div><div class="aside-list"><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E9%83%A8%E7%BD%B2Zabbix-Server5-0/" title="Shell程序——部署Zabbix-ServerV5.0">Shell程序——部署Zabbix-ServerV5.0</a><time datetime="2022-02-17T03:32:00.000Z" title="发表于 2022-02-17 11:32:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E9%83%A8%E7%BD%B2Harbor/" title="Shell程序——部署Harbor">Shell程序——部署Harbor</a><time datetime="2022-02-17T03:31:00.000Z" title="发表于 2022-02-17 11:31:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94Mysql%E5%A4%87%E4%BB%BD/" title="Shell程序——Mysql备份">Shell程序——Mysql备份</a><time datetime="2022-02-17T03:30:00.000Z" title="发表于 2022-02-17 11:30:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E6%89%B9%E9%87%8F%E4%BF%9D%E5%AD%98Docker-image/" title="Shell程序——批量保存Docker_image">Shell程序——批量保存Docker_image</a><time datetime="2022-02-17T03:29:00.000Z" title="发表于 2022-02-17 11:29:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E5%85%A8%E6%AE%B5IP%E6%89%AB%E6%8F%8F/" title="Shell程序——全段IP扫描">Shell程序——全段IP扫描</a><time datetime="2022-02-17T03:28:00.000Z" title="发表于 2022-02-17 11:28:00">2022-02-17</time></div></div></div></div></div></div></main><footer id="footer"><div id="footer-wrap"><div class="copyright">&copy;2020 - 2022 By ZuSir</div><div class="framework-info"><span>框架 </span><a target="_blank" rel="noopener" href="https://hexo.io">Hexo</a><span class="footer-separator">|</span><span>主题 </span><a target="_blank" rel="noopener" href="https://github.com/jerryc127/hexo-theme-butterfly">Butterfly</a></div></div></footer></div><div id="rightside"><div id="rightside-config-hide"><button id="readmode" type="button" title="阅读模式"><i class="fas fa-book-open"></i></button><button id="hide-aside-btn" type="button" title="单栏和双栏切换"><i class="fas fa-arrows-alt-h"></i></button></div><div id="rightside-config-show"><button id="rightside_config" type="button" title="设置"><i class="fas fa-cog fa-spin"></i></button><button id="go-up" type="button" title="回到顶部"><i class="fas fa-arrow-up"></i></button></div></div><div><script src="/js/utils.js"></script><script src="/js/main.js"></script><div class="js-pjax"></div><script defer="defer" id="fluttering_ribbon" mobile="true" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/dist/canvas-fluttering-ribbon.min.js"></script><script async data-pjax src="//busuanzi.ibruce.info/busuanzi/2.3/busuanzi.pure.mini.js"></script></div></body></html>